import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Vector;

public class FreeSpaceDetection implements Runnable
{
	Thread t;
	int carRegnum=0;
	int startTime=0;
	int endTime=0;
	int slotNumber=0;
	int[][] bitMap;
	
	Vector<Integer> summaryVector = new Vector<Integer>();
    ArrayList<slotInfo>  defragList = new ArrayList<slotInfo>();  
    DefragmentAllocations2 defragment = new DefragmentAllocations2();

	
	FreeSpaceDetection(Vector<Integer> summaryVectorPassed, int[][] bitMapPassed,int carRegnumPassed,int startTimePassed, int endTimePassed,ArrayList<slotInfo> defragListPassed)
	{
		String regnumString = Integer.toString(carRegnumPassed);
		t = new Thread(this,regnumString);
		carRegnum = carRegnumPassed;
		startTime = startTimePassed;
		endTime = endTimePassed;
		bitMap=bitMapPassed;
		summaryVector=summaryVectorPassed;
		defragList = defragListPassed;
		t.start();
	}

	public FreeSpaceDetection() 
	{
	}

	public Vector<Integer> calculateTimeSlots(int startTime, int endTime)
	{
		int startTime1=0;
		int endTime1=0;   
		int time1,time2;
		Vector<Integer> timeSlotsOccupied = new Vector<Integer>();
		
		if(startTime%100!=0)
		{
			startTime1=((startTime/100)*100)+50;
		}
		else
			startTime1=startTime;
		
		if(endTime%100!=0)
		{
			endTime1=((endTime/100)*100)+50;
		}
		else
			endTime1=endTime;
		
		for(int i=startTime1;i<=endTime1-50;i+=50)
		{
			time1=i/100;
			time2=(i+50)/100;
			timeSlotsOccupied.add(time1+time2);
							
		}
		return(timeSlotsOccupied);
		
	}
	
	public void currentReservationsVector(Vector<Integer> summaryVector,int carRegnum, int startTime1, int endTime1,int slotNumber1 )
	{
		
		//Inserting the Registration number, start time and end time which comprise one record in the summary vector
		
		summaryVector.add(carRegnum);
		summaryVector.add(startTime1);
		summaryVector.add(endTime1);
		
		//Also insert the slot number at which the reservation is being made for. This will be randomly generated(mostly
		//lowest available/particular algorithm based) but not provided by the user.  This is useful during defragmentation.
		
		summaryVector.add(slotNumber1);
		System.out.println("Summary array is "+summaryVector);

	}
	
	public int allotSlot(Vector<Integer> checkTimeSlots) 
	{
		
		int parkingSlot = 0;
		int slot = 0;
		int startIndex = 0;
		int stopIndex = 0;
		int vectorSize = 0;
		int timeSlotCount = 0;
		boolean foundSlot = false;
		
		vectorSize = checkTimeSlots.size();
		startIndex = checkTimeSlots.get(0);
		stopIndex = checkTimeSlots.get(vectorSize - 1);
		timeSlotCount = stopIndex - startIndex + 1;
		
	    String regnumString = Integer.toString(carRegnum);
	    String startIndexString = Integer.toString(startIndex);
	    String stopIndexString = Integer.toString(stopIndex);
 
		while(slot < 500)
		{
			int tempCount = 0;
			boolean foundOverlap = false;

			for(int time = startIndex; time<=stopIndex; time++)
			{				
				if (bitMap[time][slot] == 1)
				{
					foundOverlap = true;
					break;
				}
				
				else
				{					
					tempCount = tempCount + 1;
					continue;
				}
					
					
			}
			if (foundOverlap == true)
			{
				slot++;
			}
					
			if(tempCount == timeSlotCount)
			{
				parkingSlot = slot;
				foundSlot = true;
				break;
			}
			else
				continue;
		}
		
		if(foundSlot == true)
		{
			String parkingSlotString = Integer.toString(parkingSlot);
			slotInfo user = new slotInfo(regnumString,stopIndexString, startIndexString,parkingSlotString);  
		    defragList.add(user);  
			return parkingSlot;
		}
		else
			return 1000;
	}

	public void run()
	{
		Vector<Integer> timeSlotsOccupied = new Vector<Integer>();
		timeSlotsOccupied = calculateTimeSlots(startTime, endTime);
		int slotPassed = allotSlot(timeSlotsOccupied);
		insertSlotIntoDatabase(carRegnum,slotPassed);
		if (slotPassed !=1000)
		{
			defragment.insertBitMap(bitMap,timeSlotsOccupied,slotPassed);
			currentReservationsVector(summaryVector, carRegnum, startTime, endTime,slotPassed);
		}
		else
			System.out.println("Unable to Find Slot");
		

	}
	
	public void insertSlotIntoDatabase(int carRegnum, int slot)
	{
		Connection conn = null;

		try
        {									

            String userName = "root";
            String password = "";
            String url = "jdbc:mysql://localhost/parkalot_system";
            Class.forName ("com.mysql.jdbc.Driver").newInstance ();
            conn = DriverManager.getConnection (url, userName, password);
        }
        catch (Exception e)
        {
            System.err.println ("Cannot connect to database server");
        }
        finally
        {
            if (conn != null)
            { 
            	Statement stmt = null;
            	try
	            {
	            	   stmt = conn.createStatement();
	            	   stmt.executeUpdate("UPDATE fsbm_data set slot ="+slot+" WHERE car_regnum="+carRegnum);
	            }
            	catch (SQLException e1)
	            {
						e1.printStackTrace();
	            }
            }
        }
	
	}
	                 
}
