import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Random;


public class matrix_control 
{

	public static double log(double poisson_random) 
	{
		return Math.log(poisson_random)/Math.log(2.718);
	}
	
	public static int sleep_time(double lambda_rate)
	{
		
		Random generator = new Random();
		double angle = generator.nextDouble()*0.99999 +0.00001;
		DecimalFormat twoDForm = new DecimalFormat("#.##########");
		String temp=twoDForm.format(angle);
		double poisson_random = Double.valueOf(temp.trim()).doubleValue();
		double num=-log(poisson_random)/lambda_rate;
		double sleep_time=num*60*60*1000;
		DecimalFormat twoDForm1 = new DecimalFormat("#");
		String temp1=twoDForm1.format(sleep_time);
		int sleep_time_formatted = Integer.parseInt(temp1.trim());
		return(sleep_time_formatted);

		
	}
	
	
	public static void main (String args []) 
	{	
		
		//Arrival Thread Variable initialization
		
		String arrival_thread_regnum="";
		String final_slot="";
        HashMap<String,matrix_new_arrival> hashMap = new HashMap<String,matrix_new_arrival>();

		
		//Setting up database connection
		 
		Connection conn = null;

        try
        {
            String userName = "root";
            String password = "";
            String url = "jdbc:mysql://localhost/parkalot_system";
            Class.forName ("com.mysql.jdbc.Driver").newInstance ();
            conn = DriverManager.getConnection (url, userName, password);
        }
        catch (Exception e)
        {
            System.err.println ("Cannot connect to database server");
        }
        finally
        {
            if (conn != null)
            { 
            	Statement stmt = null;
            	int answer=1;
		               try
		               {
		            	   while(answer==1)
		            	   {
							stmt = conn.createStatement();
							
							//Selecting a slot which is vacant and has not been alloted yet. This will then be alloted to the next incoming user.
							
							ResultSet rs = stmt.executeQuery("SELECT slot_number FROM `use_slot_temp` WHERE slot_status = 'Vacant' and slot_alloted=0 and slot_number<12000");
							
							if(rs.next())
							{
								final_slot=rs.getString(1);
									
							//Selecting a user randomly from the user table such that he is not in the parking lot and has not been used till now.
								
								ResultSet rs1=stmt.executeQuery("SELECT MIN(temp_regnum) FROM temp_slot where temp_used='0' and temp_block='0' and temp_regnum<=10499");
								if (rs1.next())
								{
									arrival_thread_regnum = rs1.getString(1);
									
							//Calling thread for each new user and sending his registration number and advance reservation spot number
									matrix_new_arrival temp = new matrix_new_arrival(hashMap,arrival_thread_regnum,final_slot);
									hashMap.put(new String(arrival_thread_regnum),temp);

									
									//Iterator<String> iterator = hashMap.keySet().iterator();  
									/*   
									while (iterator.hasNext()) 
									{  
									   String key = iterator.next().toString();  
									   String value = hashMap.get(key).toString();  
									   System.out.println(key + " " + value);  
									}  
									*/
									try 
									{
										int thread_sleep_time=sleep_time(500.0);
										thread_sleep_time = 6000;
										System.out.println("NEXT ARRIVAL IN "+thread_sleep_time/60000+" MINUTES OR "+thread_sleep_time/1000+" SECONDS");
										
										Thread.sleep(thread_sleep_time);
										//int total_time=thread_sleep_time;
										//Thread.sleep(total_time);
									} 
									catch (InterruptedException e) 
									{
										e.printStackTrace();
									}								
								}
								else
									System.out.println("No more users available to simulate the arrival threads");
							 }
		            	   }	
	            	   
		               }
		               catch (SQLException e1)
		               {
							e1.printStackTrace();
		               }

            		}
        	}
        System.out.println("Exiting Main");
 	}

}
